{       }
{       }
{   8, 16, 32 bpp     }
{ : Ivan Polyacov, cooler@tut.by }

unit DirectText;
interface
  const
   {  ,       }
   clipx1:longint=0;
   clipx2:longint=1024;
   clipy1:longint=0;
   clipy2:longint=768;
  type
   {    }
   fonttype=record
     name:string[9];
     fsize:word;
     xchar,ychar:byte;
     t:byte;
     chsize:byte;
     prop:array[32..255] of byte;
     data:pointer;
   end;
  var
   fonts:array[1..10] of fonttype;
   fontnum,fontcnt,fontmode:byte;
   color1,color2,color3:longint; // 
   colorgrad:array[0..31] of integer; //     ( )
   grad_mode:boolean=false; //  
   LastError:integer;
   LinAddr:longint;
   hsize,vsize:longint;
   bpline:longint;
   PixelFormat,shlval:integer; // 1,2 or 4 bytes length

   //   :
   // buf:  ,
   // ( ,   BMP    )
   // width,height -   
   // lpitch -     
   // (    ""    BMP!)
   // depth -   (   )
  procedure SetBuffer(buf:pointer;width,height,lPitch,depth:integer);

   //     (  !)
  procedure registerfont(p:pointer);

   //    
   // posit -   
  procedure loadfont(name:string;posit:longint);

   //    
  procedure setfont(n:byte);

   //  
  procedure wrtstr(x,y:longint;st:string);

   //    
  procedure wrtStrCenter(x,y:longint;st:string);

   //    
  procedure wrtStrAlign(x1,x2,y:longint;st:string);

   //   
  procedure setfontmode(m:byte);

   //      ( )
  function getstrlen(st:string):integer;

   //    
  function fonth:Byte;

implementation
 var
  writechar:procedure(x,y:longint;ch:char);

  procedure writechar8(x,y:longint;ch:char); forward;
  procedure writechar16(x,y:longint;ch:char); forward;
  procedure writechar32(x,y:longint;ch:char); forward;

  procedure SetBuffer(buf:pointer;width,height,lPitch,depth:integer); export;
   begin
    LinAddr:=longint(buf);
    hsize:=width; vsize:=height;
    bpline:=lPitch;
    PixelFormat:=depth;
    if depth=1 then begin
     shlval:=0;
     writechar:=@writechar8;
    end;
    if depth=2 then begin
     shlval:=1;
     writechar:=@writechar16;
    end;
    if depth=4 then begin
     shlval:=2;
     writechar:=@writechar32;
    end;
   end;

  procedure registerfont(p:pointer); export;
   begin
    if fontcnt>=10 then begin
     LastError:=2; exit;
    end;
    inc(fontcnt);
    move(p^,fonts[fontcnt],240);
    fonts[fontcnt].data:=pointer(longint(p)+240);
    fontnum:=fontcnt;
   end;
  procedure loadfont(name:string;posit:longint); export;
   var
    f:file;
   begin
    if fontcnt>=10 then begin
     LastError:=2; exit;
    end;
    assign(f,name);
    reset(f,1);
    seek(f,posit);
    if ioresult<>0 then begin
     LastError:=1; exit;
    end;
    inc(fontcnt);
    blockread(f,fonts[fontcnt],240);
    with fonts[fontcnt] do begin
     getmem(data,chsize*224);
     blockread(f,data^,chsize*224);
    end;
    close(f);
    fontnum:=fontcnt;
   end;
  procedure setfont(n:byte); export;
   begin
    if n<=fontcnt then fontnum:=n;
   end;
  procedure setfcol(c1,c2,c3:byte); export;
   begin
    color1:=c1;
    color2:=c2;
    color3:=c3;
   end;
  function fontH:byte; export;
   begin
    fontH:=fonts[fontnum].ychar;
   end;

  procedure writechar8(x,y:longint;ch:char);
   var
    c1,c2,c3:byte;
    colormas:pointer;
    n,s,ysize:byte;
    sy,cnt,d:longint;
    o:longint;
   begin
    c1:=color1; c2:=color2; c3:=color3; n:=byte(ch);
    s:=0; colormas:=@colorgrad;
    with fonts[fontnum] do begin
     cnt:=prop[n]; ysize:=ychar;
     if x+prop[n]<=clipx1 then exit;
     if x>clipx2 then exit;
     if x<clipx1 then begin s:=clipx1-x; cnt:=cnt-(clipx1-x);
       x:=clipx1;  end;
     s:=s*2;
     if x+prop[n]>clipx2 then cnt:=clipx2-x+1;
     o:=longint(data)+(n-32)*chsize;
     d:=xchar div 4;
     asm
      pushad
      push es
      mov eax,y
      mov ebx,bpline
      imul ebx
      add eax,x
      mov edi,eax
      add edi,linAddr

      mov dl,ysize
      mov esi,o
@01:
      cmp grad_mode,0
      jz @11
      mov eax,colormas
      mov al,[eax]
      mov c1,al
      add colormas,4
@11:  lodsd
      mov cl,s
      shr eax,cl
      mov ecx,cnt
      push edi
@02:
      mov dh,al
      and dh,3
      jz @06
      cmp dh,1
      jne @05
      mov dh,c1
      mov es:[edi],dh
      jmp @06
@05:  cmp dh,2
      jne @07
      mov dh,c2
      mov es:[edi],dh
      jmp @06
@07:  mov dh,c3
      mov es:[edi],dh
@06:  inc edi
      shr eax,2
      loop @02
      pop edi
      add edi,bpline
      sub esi,4
      add esi,d
      dec dl
      jnz @01
      pop es
      popad
     end;
    end;
   end;

  procedure writechar16(x,y:longint;ch:char);
   var
    c1,c2,c3:longint;
    colormas:pointer;
    n,s,ysize:byte;
    sy,cnt,d:longint;
    o:longint;
   begin
    c1:=color1; c2:=color2; c3:=color3; n:=byte(ch);
    s:=0; colormas:=@colorgrad;
    with fonts[fontnum] do begin
     cnt:=prop[n]; ysize:=ychar;
     if x+prop[n]<=clipx1 then exit;
     if x>clipx2 then exit;
     if x<clipx1 then begin s:=clipx1-x; cnt:=cnt-(clipx1-x);
       x:=clipx1;  end;
     s:=s*2;
     if x+prop[n]>clipx2 then cnt:=clipx2-x+1;
     o:=longint(data)+(n-32)*chsize;
     d:=xchar div 4;
     asm
      pushad
      push es
      mov eax,y
      mov ebx,bpline
      imul ebx
      shl x,1
      add eax,x
      mov edi,eax
      add edi,linAddr

      mov dl,ysize
      mov esi,o
@01:  cmp grad_mode,0
      jz @11
      mov eax,colormas
      mov eax,[eax]
      mov c1,eax
      add colormas,4
@11:  lodsd
      mov cl,s
      shr eax,cl
      mov ecx,cnt
      push edi
@02:
      push edx
      mov dh,al
      and dh,3
      jz @06
      cmp dh,1
      jne @05
      mov dx,word ptr c1
      mov es:[edi],dx
      jmp @06
@05:  cmp dh,2
      jne @07
      mov dx,word ptr c2
      mov es:[edi],dx
      jmp @06
@07:  mov dx,word ptr c3
      mov es:[edi],dx
@06:  inc edi
      shr eax,2
      inc edi
      pop edx
      loop @02
      pop edi
      add edi,bpline
      sub esi,4
      add esi,d
      dec dl
      jnz @01
      pop es
      popad
     end;
    end;
   end;

  procedure writechar32(x,y:longint;ch:char);
   var
    c1,c2,c3:longint;
    colormas:pointer;
    n,s,ysize:byte;
    sy,cnt,d:longint;
    o:longint;
   begin
    c1:=color1; c2:=color2; c3:=color3; n:=byte(ch);
    s:=0; colormas:=@colorgrad;
    with fonts[fontnum] do begin
     cnt:=prop[n]; ysize:=ychar;
     if x+prop[n]<=clipx1 then exit;
     if x>clipx2 then exit;
     if x<clipx1 then begin s:=clipx1-x; cnt:=cnt-(clipx1-x);
       x:=clipx1;  end;
     s:=s*2;
     if x+prop[n]>clipx2 then cnt:=clipx2-x+1;
     o:=longint(data)+(n-32)*chsize;
     d:=xchar div 4;
     asm
      pushad
      push es
      mov eax,y
      mov ebx,bpline
      imul ebx
      shl x,2
      add eax,x
      mov edi,eax
      add edi,linAddr

      mov dl,ysize
      mov esi,o
@01:  cmp grad_mode,0
      jz @11
      mov eax,colormas
      mov eax,[eax]
      mov c1,eax
      add colormas,4
@11:  lodsd
      mov cl,s
      shr eax,cl
      mov ecx,cnt
      push edi
@02:
      push edx
      mov dh,al
      and dh,3
      jz @06
      cmp dh,1
      jne @05
      mov edx,c1
      mov es:[edi],edx
      jmp @06
@05:  cmp dh,2
      jne @07
      mov edx,c2
      mov es:[edi],edx
      jmp @06
@07:  mov edx,c3
      mov es:[edi],edx
@06:  add edi,4
      shr eax,2
      pop edx
      loop @02
      pop edi
      add edi,bpline
      sub esi,4
      add esi,d
      dec dl
      jnz @01
      pop es
      popad
     end;
    end;
   end;

  procedure wrtstr(x,y:longint;st:string); export;
   var
    i:longint;
   begin
    for i:=1 to length(st) do begin
     writechar(x,y,st[i]);
     x:=x+fonts[fontnum].prop[byte(st[i])]+fontmode;
    end;
   end;
  procedure wrtstrCenter(x,y:longint;st:string); export;
   begin
    WrtStr(x-GetStrLen(st) div 2,y,st);
   end;
  procedure wrtstrAlign(x1,x2,y:longint;st:string); export;
   var
    i,len:longint;
    fl:boolean;
    dx,ddx:single;
   begin
    if length(st)=0 then exit;
    len:=GetStrLen(st);
    if (x2-x1<Len) or (x2-x1>Len+32) then
     WrtStr(x1,y,st) else
    begin
     dx:=0;
     ddx:=(x2-x1-len)/length(st);
     for i:=1 to length(st) do begin
      writechar(x1+round(dx),y,st[i]);
      x1:=x1+fonts[fontnum].prop[byte(st[i])]+fontmode;
      dx:=dx+ddx;
     end;
    end;
   end;

  procedure setfontmode(m:byte); export;
   begin
    fontmode:=m;
   end;
  function getstrlen(st:string):integer; export;
   var
    l,i:longint;
   begin
    l:=0;
    for i:=1 to length(st) do
     l:=l+fonts[fontnum].prop[byte(st[i])]+fontmode;
    l:=l-fontmode;
    getstrlen:=l;
   end;
  function getfontnum(name:string):integer; export;
   var
    i:longint;
   begin
    for i:=1 to fontcnt do
     if fonts[i].name=name then begin
      getfontnum:=i; exit;
     end;
    getfontnum:=0;
   end;

 begin
  fontcnt:=0;
  fontmode:=0;
  LastError:=0;
end.

